import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.ole.win32.*;
import org.eclipse.swt.widgets.*;
import com.google.soap.search.*;

public class GoogleBrowser {

    /** e擾GoogleIdZbg */
    private String googleId = "L[";

    private Shell shell;
    private Label label1;
    private Text queryText;
    private Button button;
    private Table table;
    //ȉWin32ˑIuWFNg
    private OleFrame webFrame; 
    private OleControlSite webControlSite;
    private OleAutomation oleAutomation;
    private static final String [] columnTitles 
        = {"","^Cg","URL",""};
    
    public Shell open(Display display) {
        shell = new Shell (display);

        GridLayout layout = new GridLayout();
        layout.numColumns = 3;
        shell.setLayout(layout);

        label1 = new Label(shell, SWT.LEFT);
        label1.setText("");
        queryText = new Text(shell, SWT.CENTER);
        button = new Button(shell, SWT.CENTER);
        button.setText("");
        button.addMouseListener(new MouseAdapter() {
            public void mouseUp(MouseEvent e) {
                doSearch();
            }
        });

        // e[u
        table = new Table (shell,SWT.SINGLE | SWT.V_SCROLL | SWT.H_SCROLL | SWT.FULL_SELECTION | SWT.BORDER);
        table.setSize(200,200);
        table.setHeaderVisible (true);
        table.addMouseListener(new MouseAdapter(){
            public void mouseUp(MouseEvent arg0) {
                int selectIndex = table.getSelectionIndex();
                if(selectIndex == -1) return;
                String url = table.getItem(selectIndex).getText(2);
                navigate(url);
            }
        });

        for (int i = 0; i < columnTitles.length; i++) {
            TableColumn tableColumn = new TableColumn(table, SWT.NULL);
            tableColumn.setText(columnTitles[i]);
        }
        for (int i=0; i<10; i++) {
            TableItem item = new TableItem (table, SWT.NULL);
        }
        for (int i = 0; i < columnTitles.length; i++) {
            TableColumn tableColumn = table.getColumn(i);
            tableColumn.setText(columnTitles[i]);
            tableColumn.pack();
        }
        
        // WebuEU\̈
        webFrame = new OleFrame(shell, SWT.NONE);
        webControlSite = new OleControlSite(webFrame, SWT.NONE, "Shell.Explorer");
        oleAutomation = new OleAutomation(webControlSite);

        // OLEgp\ɂ
        boolean activated = (webControlSite.doVerb(OLE.OLEIVERB_INPLACEACTIVATE) == OLE.S_OK);

        // GridݒiɐLтݒj
        GridData gridData1 = new GridData( );
        gridData1.horizontalAlignment = GridData.FILL;
        gridData1.grabExcessHorizontalSpace = true;
        queryText.setLayoutData(gridData1);

        // GridݒicɐLтݒCcolspan=3j
        GridData gridData2 = new GridData();
        gridData2.horizontalAlignment = GridData.FILL;
        gridData2.grabExcessHorizontalSpace = true;
        gridData2.horizontalSpan = 3;
        table.setLayoutData(gridData2);

        // GridݒicɐLтݒCcolspan=3j
        GridData gridData3 = new GridData();
        gridData3.horizontalAlignment = GridData.FILL;
        gridData3.grabExcessHorizontalSpace = true;
        gridData3.verticalAlignment = GridData.FILL;
        gridData3.grabExcessVerticalSpace = true;
        gridData3.horizontalSpan = 3;
        webFrame.setLayoutData(gridData3);
        
        shell.setText("GoogleSWT");
        shell.setSize(600,500);
        shell.open ();
        return shell;
    }

    /** IEgp邽߂̂܂Ȃ */
    public void navigate(String url) {
        int[] rgdispid = oleAutomation.getIDsOfNames(new String[]{"Navigate", "URL"}); 
        int dispIdMember = rgdispid[0];
        Variant[] rgvarg = new Variant[1];
        rgvarg[0] = new Variant(url);
        int[] rgdispidNamedArgs = new int[1];
        rgdispidNamedArgs[0] = rgdispid[1]; // identifier of argument
        Variant pVarResult = oleAutomation.invoke(dispIdMember, rgvarg, rgdispidNamedArgs);
    }
    
    /** Google */
    public void doSearch() {
        if(queryText.getText() == "") return;

        GoogleSearchResult result = null;
        GoogleSearch google = new GoogleSearch();
        google.setKey(googleId);
        google.setQueryString(queryText.getText());
        try {
            result = google.doSearch();
        } catch (GoogleSearchFault e) {
            e.printStackTrace();
        }

        GoogleSearchResultElement[] elements = result.getResultElements();
        table.removeAll();
        for (int i = 0; i < elements.length; i++) {
            GoogleSearchResultElement el = elements[i];
            TableItem item = new TableItem (table, SWT.NULL);
            String[] data = {"" + (i + 1), el.getTitle(), el.getURL(), el.getSummary()};
            item.setText(data);
        }
    }
        
    public static void main (String [] args) {
        Display display = new Display();
        Shell shell = new GoogleBrowser().open(display);
        // EChEj܂Ń[v
        while (!shell.isDisposed ()) {
            if (!display.readAndDispatch ()) display.sleep ();
        }
        display.dispose ();
    }
}